config/routes.rb
Rails.application.routes.draw do
  root "tasks#index"
  
  resources :tasks do
    put :test
  end
  

end

app/models/task.rb
class Task < ActiveRecord::Base
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy]
  
  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
    if !params[:test]
      @ind = 1
    else
      @ind = 2
      respond_to do |format|
        format.html { redirect_to @task }
        format.js
      end
    end
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)
    @task.save
    respond_to do |format|
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.js
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: 'Task was successfully destroyed.' }
      format.js
    end
  end
  
  def test
    @task = Task.find(params[:task_id])
    @task.update(:status => !@task.status)
    respond_to do |format|
      format.html { redirect_to tasks_url }
      format.js
    end
  end
  
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def task_params
      params.require(:task).permit(:content, :status)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>ToDoList</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
 

</head>
<body>

<%= yield %>

</body>
</html>

app/views/tasks/_form.html.erb
<%= form_for @task, remote: true do |f| %>
  <div class="field">
    <%= f.label :content %><br>
    <%= f.text_area :content %>
  </div>
  <div class="field" style="display:none;">
    <%= f.label :status %><br>
    <%= f.check_box :status %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tasks/_task.html.erb
<div id="edited_task_<%= task.id %>" class="all_task" style="background-color:<% if task.status%>blue<% else %>red<% end %>;">
    <p><%= task.content %></p>
    <h1><%= task.status %></h1>
    <%= link_to "Trash", task, remote: true, method: :delete, data: { confirm: "Sure ?" } %>
    <%= link_to "Test1", task_test_path(task), remote: true, method: :put %>

</div>

app/views/tasks/cancel_new.js.erb
$('#new_link_cancel').slideUp(350);
$('#new_link').slideDown(350);
$('#task-form').slideUp(350);

app/views/tasks/create.js.erb
$('#new_task').slideUp(350);
$('#new_link').slideDown(350);
$('#new_link_cancel').slideUp(350);
$('#tasks_list').append( '<%= j render(@task) %>');
$('edited_task_<%= @task.id %>').css("display","none");
$('edited_task_<%= @task.id %>').slideDown(350);
$('#edited_task_<%= @task.id %>').css("background-color", "red");

app/views/tasks/destroy.js.erb
$('#edited_task_<%= @task.id %>').slideUp(350);
$('#edited_task_<%= @task.id %>').remove();

app/views/tasks/edit.html.erb
<h1>Editing Task</h1>

<%= render 'form' %>

<%= link_to 'Show', @task %> |
<%= link_to 'Back', tasks_path %>

app/views/tasks/index.html.erb
<div class="NewTaskLink"><%= link_to "New Task", new_task_path, id: "new_link", remote: true %></div>
<div class="CancelNewTaskLink"><%= link_to "Cancel", '#', id: "new_link_cancel", style: "display:none" %></div>
<div class="Finished"><%= link_to "show finished", root_path(:test => 3), remote: true %></div>

<div id='task-form' style="display:none;"></div>
<div id="tasks_list">
  <% @tasks.each do |task| %>
  <%= render task %>
  <% end %>
</div>

app/views/tasks/index.js.erb
<% if @ind == 2 %>
    <% @tasks.each do |t| %>
        <% if t.status %>
                if  ($('#edited_task_<%= t.id %>').css('display') == 'none')
                    $('#edited_task_<%= t.id %>').slideDown(350);
                else
                    $('#edited_task_<%= t.id %>').slideUp(350);
        <%end%>
    <%end%>
<%end%>

app/views/tasks/new.html.erb
<h1>New Task</h1>

<%= render 'form' %>

<%= link_to 'Back', tasks_path %>

app/views/tasks/new.js.erb
$('#new_link').slideUp(350);
$('#new_link_cancel').slideDown(350);
$('#task-form').html('<%= j render("form") %>');
$('#task-form').slideDown(350);

app/views/tasks/test.js.erb
$('#edited_task_<%= @task.id %>').replaceWith( "<%= j render(@task) %> ");